//
// Copyright 2016 The ANGLE Project Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.
//
// ShaderVk.cpp:
//    Implements the class methods for ShaderVk.
//

#include "libANGLE/renderer/vulkan/ShaderVk.h"

#include "common/debug.h"

namespace rx
{

ShaderVk::ShaderVk(const gl::ShaderState &data) : ShaderImpl(data)
{
}

ShaderVk::~ShaderVk()
{
}

ShCompileOptions ShaderVk::prepareSourceAndReturnOptions(const gl::Context *context,
                                                         std::stringstream *sourceStream,
                                                         std::string *sourcePath)
{
    *sourceStream << mData.getSource();
    return SH_INITIALIZE_UNINITIALIZED_LOCALS;
}

bool ShaderVk::postTranslateCompile(const gl::Context *context,
                                    gl::Compiler *compiler,
                                    std::string *infoLog)
{
    // No work to do here.
    return true;
}

std::string ShaderVk::getDebugInfo(const gl::Context *context) const
{
    return std::string();
}

}  // namespace rx
